package nc.mc.br.plugin;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.jeecg.common.util.GetDataUtil;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.framework.common.NCLocator;
import nc.bs.pub.taskcenter.BgWorkingContext;
import nc.bs.pub.taskcenter.IBackgroundWorkPlugin;
import nc.itf.gl.pub.IFreevaluePub;
import nc.itf.mc.IEteamsService;
import nc.vo.bd.b04.DeptdocVO;
import nc.vo.gl.pubvoucher.DetailVO;
import nc.vo.gl.pubvoucher.VoucherVO;
import nc.vo.glcom.ass.AssVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.VOStatus;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import u8c.log.NcLog;

/**
 * Ŀ֧
 * @author 
 *
 */
public class ProjectCostPaymentPlugin implements IBackgroundWorkPlugin{
	
	public String id = "&id=923838841108717575";//Ŀ֧id
	private IEteamsService service = NCLocator.getInstance().lookup(IEteamsService.class);
	private IFreevaluePub freepub = NCLocator.getInstance().lookup(IFreevaluePub.class);
	
	@Override
	public String executeTask(BgWorkingContext context) throws BusinessException {
		try {
			String code = service.getCode();
			String token = service.getToken(code);
			JSONArray alldata = service.getAllId(id,token);
			List<String> ids = new ArrayList<String>();
			List<String> serNums = new ArrayList<String>();
			for (int i = 0; i < alldata.size(); i++) {
				JSONObject json = JSONObject.parseObject(alldata.getString(i));
				ids.add("&id="+json.getString("id"));
				serNums.add(json.getString("serNum"));
			}
			String serNum = null;
			Map<String,String> map = GetDataUtil.getVoucher(serNums);
			for (int i = 0; i < ids.size(); i++) {
				try {
					JSONObject json = service.getInfoByID(token, ids.get(i));
					//ƥֵʾNCڸƾ֤ݵı
					serNum = json.getJSONObject("flowRequest").getString("serNum");
					String currentNode = json.getJSONObject("flowRequest").getString("currentNode");
					if(map.get(serNum) != null || !"ڵ".equals(currentNode)) {
						continue;
					}
					saveVoucher(json);
				} catch (Exception e) {
					StringWriter stringWriter = new StringWriter();
					e.printStackTrace(new PrintWriter(stringWriter));
					// ȡϸϢ
					String msg = stringWriter.getBuffer().toString();	
					NcLog.info("Ŀ֧ƾ֤ʧܣţ"+serNum+"\n"+msg);
				}

			}
		} catch (Exception e) {
			StringWriter stringWriter = new StringWriter();
			e.printStackTrace(new PrintWriter(stringWriter));
			// ȡϸϢ
			String msg = stringWriter.getBuffer().toString();
			NcLog.info("Ŀ֧ƾ֤ʧ"+"\n"+msg);
		}
		return null;
	}
	
	/**
	 * ƾ֤淽
	 * @param createStrJs 
	 * @throws Exception 
	 */
	private void saveVoucher(JSONObject createStrJs) throws Exception{
		VoucherVO newvo = interfaceService(createStrJs);			
		service.saveVoucher_RequiresNew(newvo);
	}
	
	/**
	 * ƴװƾ֤vo
	 * @param map
	 * @return
	 * @throws Exception
	 */
	public VoucherVO interfaceService(JSONObject map) throws Exception {	
		//װƾ֤VO
		VoucherVO voucher = new  VoucherVO();
		//ƾ֤
		setVoucher(map,voucher);
		//ƾ֤¼VOs
		setDetail(map,voucher);
		//дͷ
		sumAmount(voucher);
		voucher.setExplanation(voucher.getDetails()[0].getExplanation());
		return voucher;
	}
	
	
	/**
	 * ƾ֤
	 * @param map 
	 * @param obj
	 * @param voucher
	 * @throws BusinessException 
	 */
	private void setVoucher(JSONObject json,VoucherVO voucher) throws Exception {		
		JSONObject formData = json.getJSONObject("formData");
		JSONObject dataDetails = formData.getJSONObject("dataDetails");
		//Ƶ
		voucher.setPk_prepared(GetDataUtil.getUserid("15800802186"));
		//ƾ֤
		voucher.setPk_vouchertype(GetDataUtil.getVoucherType("ƾ֤"));
		//˾
		voucher.setPk_corp(GetDataUtil.getCorpPK("1001"));
		
		UFDate createTime = new UFDate(formData.getDate("createTime"));
		//
		voucher.setYear(String.valueOf(createTime.getYear()));
		//ڼ
		voucher.setPeriod(String.valueOf(createTime).substring(5,7));
		//Ƶ
		voucher.setPrepareddate(createTime);
		//
		voucher.setPk_manager("N/A");
		//ǩֱʶ
		voucher.setSignflag(UFBoolean.TRUE);
		//¼ɾ־
		voucher.setDetailmodflag(UFBoolean.TRUE);
		//ϱʶ
		voucher.setDiscardflag(UFBoolean.FALSE);
		//Ƶϵͳ
		voucher.setPk_system("GL");
		//ƾ֤
		voucher.setVoucherkind(0);
		//跽ϼ
		voucher.setTotaldebit(new UFDouble(dataDetails.getString("֧ܽ")));
		//ϼ
		voucher.setTotalcredit(new UFDouble(dataDetails.getString("֧ܽ")));
		//΢Ψһʶ
		voucher.setFree2(dataDetails.getString("Զ"));
		String pk_glorg = GetDataUtil.getGlorg("1001");
		// 
		voucher.setPk_glorg(pk_glorg);
		// ʲ
		voucher.setPk_glorgbook(GetDataUtil.getGlorgbook(pk_glorg));
		voucher.setIsdifflag(UFBoolean.FALSE);	
		voucher.setStatus(VOStatus.NEW);
	}
	
	
	/**
	 * ƾ֤¼
	 * @param map 
	 * @param obj
	 * @param voucher
	 * @throws BusinessException 
	 * @throws SQLException 
	 */
	private void setDetail(JSONObject map, VoucherVO voucher) throws Exception {
		JSONObject formData = map.getJSONObject("formData");
		JSONObject dataDetails = formData.getJSONObject("dataDetails");
		JSONObject money = dataDetails.getJSONObject("֧_*");
		JSONObject costName = dataDetails.getJSONObject("_*");
		JSONArray datas = new JSONArray();
		String pk_accsubj = GetDataUtil.getAccSubject("560201",voucher.getPk_glorgbook());//Ŀ
		String pk_currtype = GetDataUtil.getCurrType("CNY");
		String deptName = dataDetails.getString("");
		DeptdocVO deptdocVO = GetDataUtil.getDept(deptName, voucher.getPk_corp());
		AssVO jobAssVO = getPubAssid("ŵ",deptdocVO,voucher.getPk_corp());
		 // formDataеÿֵתΪJSONArrayԪ
        for (String key : money.keySet()) {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("money", money.get(key));
            jsonObject.put("costName", "Ŀ֧ƾ֤");
            jsonObject.put("pk_accsubj", pk_accsubj);
            jsonObject.put("pk_currtype", pk_currtype);
            datas.add(jsonObject);
        }

		List<DetailVO> details = new ArrayList<DetailVO>();
		for (int i = 0; i < datas.size(); i++) {
			JSONObject data = datas.getJSONObject(i);
			//һһһ
			//跽¼
			setDebitVO(details, voucher,data,map,jobAssVO);
			//¼
			setCreditVO(details, voucher, data,map,jobAssVO);
		}
		DetailVO[] detailVOs = new DetailVO[details.size()]; 
		details.toArray(detailVOs);
		voucher.setDetails(detailVOs);
	}
	
	
	/**
	 * ƾ֤¼跽
	 * @param details
	 * @param voucher
	 * @param data
	 * @param map 
	 * @throws BusinessException
	 * @throws SQLException 
	 */
	private void setDebitVO(List<DetailVO> details, VoucherVO voucher, JSONObject data, JSONObject map ,AssVO jobAssVO) throws Exception {
		DetailVO vo = new DetailVO();	
		List<AssVO> listAss = new ArrayList<AssVO>();
		
		listAss.add(jobAssVO);
		AssVO[] assVOs = new AssVO[listAss.size()];
		listAss.toArray(assVOs);
		vo.setAssid(freepub.getAssID(assVOs, true));
		vo.setPk_accsubj(data.getString("pk_accsubj"));//ƿĿ
		vo.setCreditamount(UFDouble.ZERO_DBL);//
		vo.setCreditquantity(UFDouble.ZERO_DBL);
		vo.setDebitamount(new UFDouble(data.getString("money")));//跽
		vo.setDirection("D");//
		vo.setDiscardflag(UFBoolean.FALSE);
		vo.setExcrate1(UFDouble.ZERO_DBL);
		vo.setExcrate2(UFDouble.ONE_DBL);
		vo.setExplanation(data.getString("costName"));//ժҪ
		vo.setFraccreditamount(UFDouble.ZERO_DBL);
		vo.setFracdebitamount(UFDouble.ZERO_DBL);
		vo.setLocalcreditamount(UFDouble.ZERO_DBL);//ȫִ
		vo.setLocaldebitamount(new UFDouble(data.getString("money")));//跽
		vo.setPeriod(voucher.getPeriod());//ڼ
		vo.setPk_corp(voucher.getPk_corp());
		vo.setPk_currtype(data.getString("pk_currtype"));//
		vo.setPk_glbook(voucher.getPk_glbook());
		vo.setPk_glorg(voucher.getPk_glorg());
		vo.setPk_glorgbook(voucher.getPk_glorgbook());
		vo.setPk_manager(voucher.getPk_manager());
		vo.setPk_system(voucher.getPk_system());
		vo.setPk_vouchertype(voucher.getPk_vouchertype());//ƾ֤
		vo.setPrepareddate(voucher.getPrepareddate());
		vo.setYear(voucher.getYear());
		details.add(vo);		
	}
	
	
	/**
	 * ƾ֤¼
	 * @param details
	 * @param voucher
	 * @param data
	 * @param map 
	 * @throws BusinessException
	 */
	private void setCreditVO( List<DetailVO> details,VoucherVO voucher, JSONObject data, JSONObject map, AssVO jobAssVO) throws Exception {
		DetailVO vo = new DetailVO();
		List<AssVO> listAss = new ArrayList<AssVO>();
		listAss.add(jobAssVO);
		AssVO[] assVOs = new AssVO[listAss.size()];
		listAss.toArray(assVOs);
		vo.setAssid(freepub.getAssID(assVOs, true));
		vo.setPk_accsubj(data.getString("pk_accsubj"));//ƿĿ 
		vo.setCreditamount(new UFDouble(data.getString("money")));//
		vo.setDebitamount(UFDouble.ZERO_DBL);//跽
		vo.setDirection("C");//
		vo.setDiscardflag(UFBoolean.FALSE);
		vo.setExcrate1(UFDouble.ZERO_DBL);
		vo.setExcrate2(UFDouble.ONE_DBL);
		vo.setExplanation(data.getString("costName"));//ժҪ
		vo.setFraccreditamount(UFDouble.ZERO_DBL);
		vo.setFracdebitamount(UFDouble.ZERO_DBL);
		vo.setLocalcreditamount(new UFDouble(data.getString("money")));//ȫִ
		vo.setLocaldebitamount(UFDouble.ZERO_DBL);//跽
		vo.setPeriod(voucher.getPeriod());//ڼ
		vo.setPk_corp(voucher.getPk_corp());
		vo.setPk_currtype(data.getString("pk_currtype"));//
		vo.setPk_glbook(voucher.getPk_glbook());
		vo.setPk_glorg(voucher.getPk_glorg());
		vo.setPk_glorgbook(voucher.getPk_glorgbook());
		vo.setPk_manager(voucher.getPk_manager());
		vo.setPk_system(voucher.getPk_system());
		vo.setPk_vouchertype(voucher.getPk_vouchertype());//ƾ֤
		vo.setPrepareddate(voucher.getPrepareddate());
		vo.setYear(voucher.getYear());
		details.add(vo);
	}
	
	/**
	 * ƾ֤¼ɺҪԭҽдͷ
	 * @param voucher
	 */
	private void sumAmount(VoucherVO voucher) {
		UFDouble amount1 = new UFDouble(0);
		UFDouble amount2 = new UFDouble(0);
		DetailVO[] vos = voucher.getDetails();
		for(DetailVO vo : vos){
			amount1 = amount1.add(vo.getCreditamount());
			amount2 = amount2.add(vo.getDebitamount());
		}
		voucher.setTotalcredit(amount1);// ϼ
		voucher.setTotaldebit(amount2);// 跽ϼ
	}
	
	/**
	 * ͨø
	 * @param pk_bdinfo 
	 * @throws SQLException 
	 */
	private AssVO getPubAssid(String checktype,DeptdocVO deptdocVO,String pk_corp) throws Exception {
		List<AssVO> list = new ArrayList<AssVO>();
		AssVO vo = new AssVO();	
		vo.setChecktypecode(deptdocVO.getDeptcode());
		vo.setChecktypename(checktype);
		vo.setPk_Checktype(GetDataUtil.getBdpkByBdInfo(checktype));	
		vo.setPk_Checkvalue(deptdocVO.getPrimaryKey());		
		vo.setCheckvaluecode(deptdocVO.getDeptcode());
		vo.setCheckvaluename(deptdocVO.getDeptname());
		vo.setUserData(true);		
		list.add(vo);
		AssVO[] assVOs = new AssVO[list.size()];
		list.toArray(assVOs);
		return vo;
	}

}
