package nc.impl.mc;

import org.jeecg.common.util.HttpHelper;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.framework.common.NCLocator;
import nc.itf.gl.voucher.IVoucher;
import nc.itf.mc.IEteamsService;
import nc.vo.gl.pubvoucher.VoucherVO;
import u8c.log.NcLog;

public class EteamsServiceImpl implements IEteamsService{
	private IVoucher cher = NCLocator.getInstance().lookup(IVoucher.class); 
	//获取code信息url
	private static String codeurl = "https://api.eteams.cn/oauth2/authorize";
	private static String corpid = "?corpid=b716cad73e783c17217426cb944fb33e";
	private static String response_type = "&response_type=code";
	private static String state = "&state=As";
	//获取accessToken信息url
	private static String tokenurl = "https://api.eteams.cn/oauth2/access_token";
	private static String app_key = "?app_key=577aff82e4ca29a51441e26ac8fa7352";
	private static String app_secret = "&app_secret=e977f407cc82fe7b6623285b72792fc7";
	private static String grant_type = "&grant_type=authorization_code";
	//根据流程表单ID获取流程左侧菜单全部数据下的所有相关数据
	private static String allidurl = "https://api.eteams.cn/workflow/v2/getAllById";
	//用户id
	private static String userid = "&userid=2150608061134965656";
	
	//根据审批数据ID查询审批数据
	private static String infourl ="https://api.eteams.cn/workflow/v2/getInfoByID";
	
	@Override
	public String getCode() throws Exception {
		//获取code
		JSONObject data = JSONObject.parseObject(HttpHelper.doGet(codeurl+corpid+response_type+state, null));
		NcLog.info("Code返回JOSN:"+data);
		if("0".equals(data.getString("errcode"))) {
			return data.getString("code");
		}else {
			throw new Exception("Code获取失败:"+data.getString("errmsg"));
		}
	}


	@Override
	public String getToken(String code) throws Exception {
		//获取token
		JSONObject data = JSONObject.parseObject(HttpHelper.doPost(tokenurl+app_key+app_secret+grant_type+"&code="+code, null));
		NcLog.info("Token返回JOSN:"+data);
		if("0".equals(data.getString("errcode"))) {
			return "?access_token="+data.getString("acessToken");
		}else {
			throw new Exception("Token获取失败:"+data.getString("errmsg"));
		}
	}


	@Override
	public JSONArray getAllId(String id,String token) throws Exception {
//		JSONObject data = JSONObject.parseObject(HttpHelper.doGet(allidurl+token+userid+id, null));
//		NcLog.info("审批数据返回JOSN:"+data);
//		if("0".equals(data.getJSONObject("message").getString("errcode"))) {
//			return JSONArray.parseArray(data.getString("requests"));
//		}else {
//			throw new Exception("审批数据获取失败"+data.getJSONObject("message").getString("errmsg"));
//		}
		//递归查询所有页数据
		JSONArray jsonArrayAll= new JSONArray();
		int pageNo=1;
		batchAllId(id,token,pageNo,jsonArrayAll);
		return jsonArrayAll;
	}
	
	/**
	 * 处理超过最大分页数量递归查询剩下页数数据
	 * @param id
	 * @param token
	 * @param pageNo
	 * @param jsonArrayAll
	 * @throws Exception
	 */
	private void batchAllId(String id,String token,int pageNo,JSONArray jsonArrayAll) throws Exception {
		JSONObject data = JSONObject.parseObject(HttpHelper.doGet(allidurl+token+userid+id+"&pageNo="+pageNo+"&pageSize=200", null));
		NcLog.info("审批数据返回JOSN:"+data);
		if("0".equals(data.getJSONObject("message").getString("errcode"))) {
			JSONArray jsonArray= JSONArray.parseArray(data.getString("requests"));
			if(null!=jsonArray&&jsonArray.size()>0) {
				for(int i=0;i<jsonArray.size();i++) {
					JSONObject json=jsonArray.getJSONObject(i);
					jsonArrayAll.add(json);
				}
				//判断当前也是否有数据  有的话查看下页是否有数据
				pageNo++;
				batchAllId(id,token,pageNo,jsonArrayAll);
			}
		}else {
			throw new Exception("审批数据获取失败"+data.getJSONObject("message").getString("errmsg"));
		}
		
	}


	@Override
	public JSONObject getInfoByID(String token, String id) throws Exception {
		JSONObject data = JSONObject.parseObject(HttpHelper.doGet(infourl+token+userid+id, null));
		
		NcLog.info("审批数据详情返回JOSN:"+data);
		if("0".equals(data.getJSONObject("message").getString("errcode"))) {
			return data;
		}else {
			throw new Exception("审批数据详情获取失败"+data.getJSONObject("message").getString("errmsg"));
		}
	}

	
	@Override
	public void saveVoucher_RequiresNew(VoucherVO newvo) throws Exception {
		cher.save(newvo, false);	
	}

}
