package org.jeecg.common.util;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.bd.b04.DeptdocVO;

public class GetDataUtil {

private static IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	
	public static String getVoucherType(String vouchtypename) throws Exception {
		String sql = "select pk_vouchertype from bd_vouchertype where vouchtypename = '"+vouchtypename+"' and sealflag is null";
		String pk_vouchertype = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if(pk_vouchertype == null) {
			throw new Exception("凭证分类"+vouchtypename+"未查到，请检查");
		}
		return pk_vouchertype;
	}
	
	
    //公司
    public static String getCorpPK(String code) throws Exception {
    	String sql = "select pk_corp from bd_corp where unitcode = '"+code+"' and dr = 0";
    	String pk_corp = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_corp == null) {
    		throw new Exception("公司"+code+"未查到，请检查");
        }
        return pk_corp;
    }
    //科目
    public static String getAccSubject(String code,String pk_glorgbook)throws Exception {
    	String sql = "select pk_accsubj from bd_accsubj where  subjcode = '"+code+"' and (dr is null or dr = 0) and pk_glorgbook='"+pk_glorgbook+"'";
    	String pk_accsubj = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_accsubj == null) {
    		throw new Exception("科目"+code+"未查到，请检查");
        }
        return pk_accsubj;
    }
    
    //查询部门
    public static DeptdocVO getDept(String name,String pk_corp)throws Exception {
    	String sql = "select pk_deptdoc,deptname from bd_deptdoc where deptname = '"+name+"' and pk_corp = '"+pk_corp+"' and dr = 0";
    	DeptdocVO deptdocVO = (DeptdocVO) iuap.executeQuery(sql, new BeanProcessor(DeptdocVO.class));
    	if (deptdocVO == null) {
    		throw new Exception("部门"+name+"未查到，请检查");
        }
        return deptdocVO;
    }
    
    //查询客商基本档案主键
    public static String getPk_cubasdoc(String custname) throws Exception {
        String sql = "select pk_cubasdoc from bd_cubasdoc where (dr is null or dr = 0)  and  custname='"+custname+"'";
        String pk_cubasdoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_cubasdoc == null) {
        	throw new Exception("客商"+custname+"未查到，请检查");
        }
        else {
        	return pk_cubasdoc;
        }
    }
    
    //查询辅助核算的核算内容
    public static String getBdpkByBdInfo(String name)throws Exception {
    	String sql = "select pk_bdinfo from bd_bdinfo where bdname = '"+name+"' and dr = 0";
    	String pk_bdinfo = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_bdinfo == null) {
    		throw new Exception("辅助核算的核算内容"+name+"未查到，请检查");
        }
        return pk_bdinfo;
    }
    
    //查询币种
    public static String getCurrType(String code)throws Exception {
    	String sql = "select pk_currtype from bd_currtype where currtypecode = '"+code+"' and dr = 0";
    	String pk_currtype = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_currtype == null) {
    		throw new Exception("币种"+code+"未查到，请检查");
        }
        return pk_currtype;
    }
	// 用户主键
    public static String getUserid(String usercode) throws Exception {
        String sql = "select cuserid from sm_user where user_code ='"+usercode+"' and isnull(dr,0) = 0";
        String cuserid = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (cuserid == null) {
        	throw new Exception("用户"+usercode+"未查到，请检查");
        }
        return cuserid;
    }
    
    //查询会计主体
    public static String getGlorg(String code)throws Exception {
    	String sql = "select pk_glorg from bd_glorg where glorgcode ='"+code+"' and dr = 0";
    	String pk_glorg = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_glorg == null) {
    		throw new Exception("会计主体"+code+"未查到，请检查");
        }
        return pk_glorg;
    }
    
    //查询会计主体账薄
    public static String getGlorgbook(String pk_glorg)throws Exception {
    	String sql = "select pk_glorgbook from bd_glorgbook where pk_glorg = '"+pk_glorg+"' and dr = 0";
    	String pk_glorgbook = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_glorgbook == null) {
    		throw new Exception("会计主体账薄"+pk_glorg+"未查到，请检查");
        }
        return pk_glorgbook;
    }
    //查询凭证
    public static Map<String,String> getVoucher(List<String> serNums)throws Exception {
    	StringBuffer sql = new StringBuffer();
    	sql.append("select Free2 from gl_voucher where Free2 in (");
    	for (int i = 0; i < serNums.size(); i++) {
    		sql.append("'"+serNums.get(i)+"',");
		}
    	//删除最后一个逗号
    	sql.deleteCharAt(sql.length() - 1);
    	sql.append(")");
    	List<String> list = (List<String>) iuap.executeQuery(sql.toString(), new ColumnListProcessor());
    	Map<String,String> map = new HashMap<String,String>();
    	for (int i = 0; i < list.size(); i++) {
    		String vaule = list.get(i);
    		map.put(vaule, vaule);
		}
		return map;
    	
    }
    
}
